
function love.load()
    love.graphics.setBackgroundColor(255, 255, 255)
    --love.graphics.setDefaultImageFilter("nearest", "nearest")

    print("hej")
    image1 = love.graphics.newImage("/graphics/torso.png")
    image2 = love.graphics.newImage("/graphics/head.png")
    image3 = love.graphics.newImage("/graphics/upperarm.png")
    image4 = love.graphics.newImage("/graphics/lowerarm.png")
    image5 = love.graphics.newImage("/graphics/table.png")
    image6 = love.graphics.newImage("/graphics/lowerarm2.png")
    image7 = love.graphics.newImage("/graphics/head2.png")
    image8 = love.graphics.newImage("/graphics/mom.png")
    image9 = love.graphics.newImage("/graphics/bg.png")
    intro1 = love.graphics.newImage("/graphics/intro1.png")
    intro2 = love.graphics.newImage("/graphics/intro2.png")
    intro3 = love.graphics.newImage("/graphics/intro3.png")

    chew = love.sound.newDecoder("/eat.wav")
    eat= love.audio.newSource(chew, "static")

    font = love.graphics.newFont(30)
    love.graphics.setFont(font)

    countdown = 0

    gameState = "intro1"

    --init_globals()
    decoder = love.sound.newDecoder("/spel2.mp3")
    music = love.audio.newSource(decoder, "stream")
    music:setLooping(true)
    love.audio.play(music)


    
end

function init_globals()
    --new_sprite(image,xLoc,yLoc,offsetX,offsetY,rotation)
    torso = new_sprite(image1,180,700,150,380,0)
    head = new_sprite(image2,torso.x+1,torso.y-340,86,370,0)
    head.lr = "l"
    head.img2 = image7
    head.frame = 1
    uarm = new_sprite(image3,torso.x+43,torso.y-350,30,15,0)
    larm = new_sprite(image4,uarm.x,uarm.y+216,39,20,0)
    larm.imgc = image6
    cookies = new_sprite(image5,700,750,155,383,0)
    bg = new_sprite(image9,0,0,0,0,0)
    mom = new_sprite(image8,860,450,500,612,0)
    mom.timer = 0
    mom.time = 5
    mom.move = 0
    mom.looking = false 

    -- none, holding or eating
    cookieState = "none"
    eating = 0
    eaten = 0

    countdown = 0
    gameState = "play"
end

function new_sprite(image,xLoc,yLoc,offsetX,offsetY,rotation,lr)
    local sprite = {img = image,
             x = xLoc,
             y = yLoc,
             ox = offsetX,
             oy = offsetY,
             r = rotation}
    return sprite
end


function love.update(dt)
    if gameState == "intro1" then
        countdown = countdown +100*dt
        if countdown >= 1000 then
            countdown = 0
            gameState = "intro2"
        end
    end
    if gameState == "intro2" then
        countdown = countdown +100*dt
        if countdown >= 1000 then
            countdown = 0
            init_globals()
        end
    end

    if gameState == "play" then
        play(dt)
    end

    if gameState == "quit" then
        countdown = countdown +100*dt
        if countdown >= 1000 then
            gameState = "intro1"
            countdown = 0
        end
    end

end

function play(dt)
    
    if cookieState ~= "eating" then 
        move_arm(dt)
    else
        eating = eating + 100*dt
        if math.random(1,50) == 1 then
            if head.frame == 1 then
                head.frame = 2
            else
                head.frame = 1
            end
    
        end

        if eating >= 100 then
            eaten = eaten + 1
            eating = 0
            cookieState = "none"
            
            print(head.frame)
        end
    end

    if mom.looking == true then
        if mom.timer >= mom.time/2 then
            mom.move = mom.move -100*dt
        else
            mom.timer = mom.timer + 1*dt
        end

        if mom.move <= 0 then
            mom.move = 0
            mom.looking = false
            mom.timer = 0
            mom.time = math.random(1,10)- eaten / 10
        end

        if cookieState ~= "none" and eaten > 0 then
            print("YOU LOSE!!")
            gameState = "quit"
        end
        
    else
        
        if mom.timer >= mom.time then
            mom.move = mom.move +(100+eaten*2)*dt
        else
            mom.timer = mom.timer + 1*dt
        end
        --print(mom.move, mom.timer)

        if mom.move >= 100 then
            mom.looking = true
            mom.timer = 0
            mom.time = math.random(1,10)- eaten / 10
        end
    end

end

function quit()

end

function move_arm(dt)

        if head.lr == "l" then
        head.r = head.r - 0.05*dt
        if head.r < -0.1 then
            head.lr = "r"
        end
    else
        head.r = head.r + 0.05*dt
        if head.r > 0.1 then
            head.lr = "l"
        end
    end

    --arm point at
    local mx = love.mouse.getX()
    local my = love.mouse.getY()

    local sx = mx - uarm.x
    local sy = my - uarm.y
    
    if sx < 0 then
        sx = 0
    end
    if sy < 0 then
        sy = 0
    end
    --print(sx,sy)
    --print(math.asin(sy/math.sqrt(sx^2+sy^2)))
    --uarm.r = math.asin(sy/math.sqrt(sx^2+sy^2))
    uarm.r = math.atan2(sy, sx) - math.pi/2
    --print(uarm.r) 

    local sx = mx - larm.x
    local sy = my - larm.y    
    larm.r = math.atan2(sy, sx) - math.pi/2


    --print(larm.r)
    --okej varför funkar fucking inte det här?!?!
    --den här ska placera om nederarmen efter överarmens rotation
    --print(uarm.r)
    larm.x = 216 - 216 * math.sin(uarm.r)
    larm.y = uarm.y + 216 * math.cos(uarm.r)
    --print(larm.x, larm.y)
end

function mf(t) 
    t = math.floor(t)
    return t
end

function love.draw() 
    if gameState == "play" then

    love.graphics.setColor(255,255,255,255)
    love.graphics.setBlendMode("alpha")
    --print(head.img,head.x,head.y,head.r,head.ox,head.oy)
    love.graphics.draw(mom.img,mom.x-mom.move,mom.y,mom.r,0.5,0.5,mom.ox,mom.oy)
    love.graphics.draw(bg.img,bg.x,bg.y,bg.r,1,1,bg.ox,bg.oy)
    --love.graphics.draw(mom.img,mom.x,mom.y,mom.r,1,1,mom.ox,mom.oy)
    love.graphics.draw(cookies.img,cookies.x,cookies.y,cookies.r,1,1,cookies.ox,cookies.oy)
    if head.frame == 1 then
        love.graphics.draw(head.img,head.x,head.y,head.r,1,1,head.ox,head.oy)
    else
        love.graphics.draw(head.img2,head.x,head.y,head.r,1,1,head.ox,head.oy)
    end
    love.graphics.draw(torso.img,torso.x,torso.y,torso.r,1,1,torso.ox,torso.oy)

    if cookieState == "holding" or cookieState == "eating" then
        love.graphics.draw(larm.imgc,larm.x,larm.y,larm.r,1,1,larm.ox,larm.oy)
    else
        love.graphics.draw(larm.img,larm.x,larm.y,larm.r,1,1,larm.ox,larm.oy)
    end

    love.graphics.draw(uarm.img,uarm.x,uarm.y,uarm.r,1,1,uarm.ox,uarm.oy)
   

    love.graphics.print("You've eaten "..tostring(eaten).." cookies",440,20)

    end

    if gameState == "intro1" then
        --12424y5jy4t23reh
        love.graphics.draw(intro1,0,0,0,1,1)
    end
    if gameState == "intro2" then
        love.graphics.draw(intro2,0,0,0,1,1)
    end

    if gameState == "quit" then
        love.graphics.draw(intro3,0,0,0,1,1)
        love.graphics.print("(You ate "..tostring(eaten).." cookies)",40,550)
    end
    
end

function love.keypressed(key)
    love.mousepressed(1,1,"l")
end


function love.mousepressed(x, y, button)
    if gameState == "play" then
    if button == "l" then

    if cookieState == "none" then
        --har han klickat på kakhögen?!
        if uarm.r > -1.49 and uarm.r < -1.37 then
            print("Got cookie! :D")
            cookieState = "holding"
        else
            print("nope", uarm.r)
        end
    end
    print(larm.r)
    if larm.r > -4.3 and larm.r < -4.06 then
        
        if cookieState == "holding" then
        print("eat cookie!")
        cookieState = "eating"
        love.audio.stop(eat)
        love.audio.play(eat)
        end
        
    end

    else
        if cookieState == "holding" then
            cookieState = "none"
        end
    end
    end

    if gameState == "quit" then
        if countdown > 100 then
            gameState = "intro1"
            countdown = 0
            return
        end
    end

    if gameState == "intro2" then
        gameState = "play"
        countdown = 0
        init_globals()
        return
    end

    if gameState == "intro1" then
        gameState = "intro2"
        countdown = 0
        return
    end
    

end
